Package org.optaplanner.core.impl.solver.termination

## Class AbstractCompositeTermination<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.solver.event.SolverLifecycleListenerAdapter<Solution_>
  - - org.optaplanner.core.impl.phase.event.PhaseLifecycleListenerAdapter<Solution_>
    - - org.optaplanner.core.impl.solver.termination.AbstractTermination<Solution_>
      - - org.optaplanner.core.impl.solver.termination.AbstractCompositeTermination<Solution_>

- All Implemented Interfaces:
    `EventListener`, `PhaseLifecycleListener<Solution_>`, `SolverLifecycleListener<Solution_>`, `Termination<Solution_>`
  Direct Known Subclasses:
    `AndCompositeTermination`, `OrCompositeTermination`

      public abstract class AbstractCompositeTermination<Solution_>
      extends AbstractTermination<Solution_>

  Abstract superclass that combines multiple `Termination`s.
  See Also:
    `AndCompositeTermination`, `OrCompositeTermination`

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected List<Termination<Solution_>>` | `terminationList` |

    - ### Fields inherited from class org.optaplanner.core.impl.solver.termination.AbstractTermination

      `logger`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `AbstractCompositeTermination​(List<Termination<Solution_>> terminationList)` |
    `` | `AbstractCompositeTermination​(Termination<Solution_>... terminations)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected List<Termination<Solution_>>` | `createChildThreadTerminationList​(SolverScope<Solution_> solverScope, ChildThreadType childThreadType)` |
    `void` | `phaseEnded​(AbstractPhaseScope<Solution_> phaseScope)` |
    `void` | `phaseStarted​(AbstractPhaseScope<Solution_> phaseScope)` |
    `void` | `solvingEnded​(SolverScope<Solution_> solverScope)` |
    `void` | `solvingStarted​(SolverScope<Solution_> solverScope)` |
    `void` | `stepEnded​(AbstractStepScope<Solution_> stepScope)` |
    `void` | `stepStarted​(AbstractStepScope<Solution_> stepScope)` |

    - ### Methods inherited from class org.optaplanner.core.impl.solver.termination.AbstractTermination

      `createChildThreadTermination`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.solver.termination.Termination

      `calculatePhaseTimeGradient, calculateSolverTimeGradient, isPhaseTerminated, isSolverTerminated`

- - ### Field Detail

    - #### terminationList

          protected final List<Termination<Solution_>> terminationList

  - ### Constructor Detail

    - #### AbstractCompositeTermination

          protected AbstractCompositeTermination​(List<Termination<Solution_>> terminationList)

    - #### AbstractCompositeTermination

          public AbstractCompositeTermination​(Termination<Solution_>... terminations)

  - ### Method Detail

    - #### solvingStarted

          public void solvingStarted​(SolverScope<Solution_> solverScope)

      Specified by:
        `solvingStarted` in interface `SolverLifecycleListener<Solution_>`
      Overrides:
        `solvingStarted` in class `SolverLifecycleListenerAdapter<Solution_>`

    - #### phaseStarted

          public void phaseStarted​(AbstractPhaseScope<Solution_> phaseScope)

      Specified by:
        `phaseStarted` in interface `PhaseLifecycleListener<Solution_>`
      Overrides:
        `phaseStarted` in class `PhaseLifecycleListenerAdapter<Solution_>`

    - #### stepStarted

          public void stepStarted​(AbstractStepScope<Solution_> stepScope)

      Specified by:
        `stepStarted` in interface `PhaseLifecycleListener<Solution_>`
      Overrides:
        `stepStarted` in class `PhaseLifecycleListenerAdapter<Solution_>`

    - #### stepEnded

          public void stepEnded​(AbstractStepScope<Solution_> stepScope)

      Specified by:
        `stepEnded` in interface `PhaseLifecycleListener<Solution_>`
      Overrides:
        `stepEnded` in class `PhaseLifecycleListenerAdapter<Solution_>`

    - #### phaseEnded

          public void phaseEnded​(AbstractPhaseScope<Solution_> phaseScope)

      Specified by:
        `phaseEnded` in interface `PhaseLifecycleListener<Solution_>`
      Overrides:
        `phaseEnded` in class `PhaseLifecycleListenerAdapter<Solution_>`

    - #### solvingEnded

          public void solvingEnded​(SolverScope<Solution_> solverScope)

      Specified by:
        `solvingEnded` in interface `SolverLifecycleListener<Solution_>`
      Overrides:
        `solvingEnded` in class `SolverLifecycleListenerAdapter<Solution_>`

    - #### createChildThreadTerminationList

          protected List<Termination<Solution_>> createChildThreadTerminationList​(SolverScope<Solution_> solverScope,
                                                                                  ChildThreadType childThreadType)